from scipy.interpolate import CubicSpline


__all__ = ['calc_lp_proportions']


p45 = [100,
        99,
        98,
        97,
        96,
        95,
        94,
        93,
        92,
        91,
        90,
        89,
        88,
        87,
        86,
        85,
        84,
        83,
        82,
        81,
        80,
        79,
        78,
        77,
        76,
        75,
        74,
        73,
        72,
        71,
        70,
        69,
        68,
        67,
        66,
        65,
        64,
        63,
        62,
        61,
        60,
        59,
        58,
        57,
        56,
        55,
        54,
        53,
        52,
        51,
        50,
        49,
        48,
        47,
        46,
        45,
        44,
        43,
        42,
        41,
        40,
        39,
        38,
        37,
        36,
        35,
        34,
        33,
        32,
        31,
        30,
        29,
        28,
        27,
        26,
        25,
        24,
        23,
        22,
        21,
        20,
        19,
        18,
        17,
        16,
        15,
        14,
        13,
        12,
        11,
        10,
        9,
        8,
        7,
        6,
        5,
        4,
        3,
        2,
        1,
        0]

xi3 = [-1,
        -0.940598,
        -0.882384,
        -0.825346,
        -0.769472,
        -0.71475,
        -0.661168,
        -0.608714,
        -0.557376,
        -0.507142,
        -0.458,
        -0.409938,
        -0.362944,
        -0.317006,
        -0.272112,
        -0.22825,
        -0.185408,
        -0.143574,
        -0.102736,
        -0.062882,
        -0.024,
        0.013922,
        0.050896,
        0.086934,
        0.122048,
        0.15625,
        0.189552,
        0.221966,
        0.253504,
        0.284178,
        0.314,
        0.342982,
        0.371136,
        0.398474,
        0.425008,
        0.45075,
        0.475712,
        0.499906,
        0.523344,
        0.546038,
        0.568,
        0.589242,
        0.609776,
        0.629614,
        0.648768,
        0.66725,
        0.685072,
        0.702246,
        0.718784,
        0.734698,
        0.75,
        0.764702,
        0.778816,
        0.792354,
        0.805328,
        0.81775,
        0.829632,
        0.840986,
        0.851824,
        0.862158,
        0.872,
        0.881362,
        0.890256,
        0.898694,
        0.906688,
        0.91425,
        0.921392,
        0.928126,
        0.934464,
        0.940418,
        0.946,
        0.951222,
        0.956096,
        0.960634,
        0.964848,
        0.96875,
        0.972352,
        0.975666,
        0.978704,
        0.981478,
        0.984,
        0.986282,
        0.988336,
        0.990174,
        0.991808,
        0.99325,
        0.994512,
        0.995606,
        0.996544,
        0.997338,
        0.998,
        0.998542,
        0.998976,
        0.999314,
        0.999568,
        0.99975,
        0.999872,
        0.999946,
        0.999984,
        0.999998,
        1]

p0 = [0,
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
        18,
        19,
        20,
        21,
        22,
        23,
        24,
        25,
        26,
        27,
        28,
        29,
        30,
        31,
        32,
        33,
        34,
        35,
        36,
        37,
        38,
        39,
        40,
        41,
        42,
        43,
        44,
        45,
        46,
        47,
        48,
        49,
        50,
        51,
        52,
        53,
        54,
        55,
        56,
        57,
        58,
        59,
        60,
        61,
        62,
        63,
        64,
        65,
        66,
        67,
        68,
        69,
        70,
        71,
        72,
        73,
        74,
        75,
        76,
        77,
        78,
        79,
        80,
        81,
        82,
        83,
        84,
        85,
        86,
        87,
        88,
        89,
        90,
        91,
        92,
        93,
        94,
        95,
        96,
        97,
        98,
        99,
        100]

xi1 = [-1,
        -0.940598,
        -0.882384,
        -0.825346,
        -0.769472,
        -0.71475,
        -0.661168,
        -0.608714,
        -0.557376,
        -0.507142,
        -0.458,
        -0.409938,
        -0.362944,
        -0.317006,
        -0.272112,
        -0.22825,
        -0.185408,
        -0.143574,
        -0.102736,
        -0.062882,
        -0.024,
        0.013922,
        0.050896,
        0.086934,
        0.122048,
        0.15625,
        0.189552,
        0.221966,
        0.253504,
        0.284178,
        0.314,
        0.342982,
        0.371136,
        0.398474,
        0.425008,
        0.45075,
        0.475712,
        0.499906,
        0.523344,
        0.546038,
        0.568,
        0.589242,
        0.609776,
        0.629614,
        0.648768,
        0.66725,
        0.685072,
        0.702246,
        0.718784,
        0.734698,
        0.75,
        0.764702,
        0.778816,
        0.792354,
        0.805328,
        0.81775,
        0.829632,
        0.840986,
        0.851824,
        0.862158,
        0.872,
        0.881362,
        0.890256,
        0.898694,
        0.906688,
        0.91425,
        0.921392,
        0.928126,
        0.934464,
        0.940418,
        0.946,
        0.951222,
        0.956096,
        0.960634,
        0.964848,
        0.96875,
        0.972352,
        0.975666,
        0.978704,
        0.981478,
        0.984,
        0.986282,
        0.988336,
        0.990174,
        0.991808,
        0.99325,
        0.994512,
        0.995606,
        0.996544,
        0.997338,
        0.998,
        0.998542,
        0.998976,
        0.999314,
        0.999568,
        0.99975,
        0.999872,
        0.999946,
        0.999984,
        0.999998,
        1]


cs_p45 = CubicSpline(xi3, p45)
cs_p0 = CubicSpline(xi1, p0)


def calc_lp_proportions(xi1, xi3):
    '''
    Parameters
    ----------
    xi1 : float
        xiD1 laminate parameter
    xi3 : float
        xiD3 laminate parameter
    
    Returns
    -------
    dict
        Returns the proportion of 0, 45, 90°
    '''
    p45 = float(cs_p45(xi3))
    
    b = xi3 + 2*xi1
    xi1_ = (1-b) / (-2) # where lines crosses it other
    print(f'b = {b}')
    print(f'xi1_ = {xi1_}')
    p0 = float(cs_p0(xi1_))

    p90 = 100 - p45 - p0

    return {
        'p0': p0,
        'p90': p90,
        'p45': p45
    }
